XMLSocketAppender Class Reference

Sends LoggingEvent objects in XML format to a remote a log server, usually a XMLSocketNode. More...

Inheritance diagram for XMLSocketAppender:

## Public Member Functions

| XMLSocketAppender ()
| ~XMLSocketAppender ()
| XMLSocketAppender (helpers::InetAddressPtr address, int port)
| Connects to remote server at `address` and `port`. More...
| XMLSocketAppender (const LogString &host, int port)
| Connects to remote server at `host` and `port`. More...
Public Member Functions inherited from SocketAppenderSkeleton
| SocketAppenderSkeleton (int defaultPort, int reconnectionDelay)
| ~SocketAppenderSkeleton ()
| SocketAppenderSkeleton (helpers::InetAddressPtr address, int port, int reconnectionDelay)
| Connects to remote server at `address` and `port`. More...
| SocketAppenderSkeleton (const LogString &host, int port, int reconnectionDelay)
| Connects to remote server at `host` and `port`. More...
void | activateOptions (log4cxx::helpers::Pool &p)
| Connect to the specified RemoteHost and Port. More...
void | close ()
| Release any resources allocated within the appender such as file handles, network connections, etc. More...
bool | requiresLayout () const
| This appender does not use a layout. More...
void | setRemoteHost (const LogString &host)
| The RemoteHost option takes a string value which should be the host name of the server where a Apache Chainsaw or compatible is running. More...
const LogString & | getRemoteHost () const
| Returns value of the RemoteHost option. More...
void | setPort (int port1)
| The Port option takes a positive integer representing the port where the server is waiting for connections. More...
int | getPort () const
| Returns value of the Port option. More...
void | setLocationInfo (bool locationInfo1)
| The LocationInfo option takes a boolean value. More...
bool | getLocationInfo () const
| Returns value of the LocationInfo option. More...
void | setReconnectionDelay (int reconnectionDelay1)
| The ReconnectionDelay option takes a positive integer representing the number of milliseconds to wait between each failed connection attempt to the server. More...
int | getReconnectionDelay () const
| Returns value of the ReconnectionDelay option. More...
void | fireConnector ()
void | setOption (const LogString &option, const LogString &value)
| Set `option` to `value`. More...
Public Member Functions inherited from AppenderSkeleton
| AppenderSkeleton ()
| AppenderSkeleton (const LayoutPtr &layout)
void | addRef () const
void | releaseRef () const
void | finalize ()
| Finalize this appender by calling the derived class' `close` method. More...
void | addFilter (const spi::FilterPtr &newFilter)
| Add a filter to end of the filter list. More...
void | clearFilters ()
| Clear the filters chain. More...
const spi::ErrorHandlerPtr & | getErrorHandler () const
| Return the currently set spi::ErrorHandler for this Appender. More...
spi::FilterPtr | getFilter () const
| Returns the head Filter. More...
const spi::FilterPtr & | getFirstFilter () const
| Return the first filter in the filter chain for this Appender. More...
LayoutPtr | getLayout () const
| Returns the layout of this appender. More...
LogString | getName () const
| Returns the name of this Appender. More...
const LevelPtr & | getThreshold ()
| Returns this appenders threshold level. More...
bool | isAsSevereAsThreshold (const LevelPtr &level) const
| Check whether the message level is below the appender's threshold. More...
void | doAppend (const spi::LoggingEventPtr &event, log4cxx::helpers::Pool &pool)
| This method performs threshold checks and invokes filters before delegating actual logging to the subclasses specific AppenderSkeleton::append method. More...
void | setErrorHandler (const spi::ErrorHandlerPtr &eh)
| Set the ErrorHandler for this Appender. More...
void | setLayout (const LayoutPtr &layout1)
| Set the layout for this appender. More...
void | setName (const LogString &name1)
| Set the name of this Appender. More...
void | setThreshold (const LevelPtr &threshold)
| Set the threshold level. More...
Public Member Functions inherited from Appender
virtual | ~Appender ()
Public Member Functions inherited from OptionHandler
virtual | ~OptionHandler ()
Public Member Functions inherited from Object
virtual const helpers::Class & | getClass () const
virtual | ~Object ()
virtual bool | instanceof (const Class &clazz) const =0
virtual const void * | cast (const Class &clazz) const =0
Public Member Functions inherited from ObjectImpl
| ObjectImpl ()
virtual | ~ObjectImpl ()
void | addRef () const
void | releaseRef () const

## Static Public Attributes

static int | DEFAULT_PORT
| The default port number of remote logging server (4560). More...
static int | DEFAULT_RECONNECTION_DELAY
| The default reconnection delay (30000 milliseconds or 30 seconds). More...
static const int | MAX_EVENT_LEN
| An event XML stream cannot exceed 1024 bytes. More...

## Protected Member Functions

virtual void | setSocket (log4cxx::helpers::SocketPtr &socket, log4cxx::helpers::Pool &p)
virtual void | cleanUp (log4cxx::helpers::Pool &p)
virtual int | getDefaultDelay () const
virtual int | getDefaultPort () const
void | append (const spi::LoggingEventPtr &event, log4cxx::helpers::Pool &pool)
| Subclasses of `AppenderSkeleton` should implement this method to perform actual logging. More...

## Additional Inherited Members

Static Public Member Functions inherited from Object
static const helpers::Class & | getStaticClass ()
static const log4cxx::helpers::ClassRegistration & | registerClass ()
Protected Attributes inherited from AppenderSkeleton
LayoutPtr | layout
| The layout variable does not need to be set if the appender implementation has its own layout. More...
LogString | name
| Appenders are named. More...
LevelPtr | threshold
| There is no level threshold filtering by default. More...
spi::ErrorHandlerPtr | errorHandler
| It is assumed and enforced that errorHandler is never null. More...
spi::FilterPtr | headFilter
| The first filter in the filter chain. More...
spi::FilterPtr | tailFilter
| The last filter in the filter chain. More...
bool | closed
| Is this appender closed? More...
log4cxx::helpers::Pool | pool
log4cxx::helpers::Mutex | mutex
Protected Attributes inherited from ObjectImpl
unsigned int volatile | ref

## Detailed Description

Sends LoggingEvent objects in XML format to a remote a log server, usually a XMLSocketNode.

The XMLSocketAppender has the following properties:

- If sent to a XMLSocketNode, remote logging is non-intrusive as far as the log event is concerned. In other words, the event will be logged with the same time stamp, NDC, location info as if it were logged locally by the client.
- XMLSocketAppenders use exclusively an XMLLayout. They ship an XML stream representing a LoggingEvent object to the server side.
- Remote logging uses the TCP protocol. Consequently, if the server is reachable, then log events will eventually arrive at the server.
- If the remote server is down, the logging requests are simply dropped. However, if and when the server comes back up, then event transmission is resumed transparently. This transparent reconneciton is performed by a connector thread which periodically attempts to connect to the server.
- Logging events are automatically buffered by the native TCP implementation. This means that if the link to server is slow but still faster than the rate of (log) event production by the client, the client will not be affected by the slow network connection. However, if the network connection is slower then the rate of event production, then the client can only progress at the network rate. In particular, if the network link to the the server is down, the client will be blocked.
  On the other hand, if the network link is up, but the server is down, the client will not be blocked when making log requests but the log events will be lost due to server unavailability.
- Even if an `XMLSocketAppender` is no longer attached to any logger, it will not be destroyed in the presence of a connector thread. A connector thread exists only if the connection to the server is down. To avoid this destruction problem, you should close the the `XMLSocketAppender` explicitly. See also next item.
  Long lived applications which create/destroy many `XMLSocketAppender` instances should be aware of this destruction problem. Most other applications can safely ignore it.
- If the application hosting the `XMLSocketAppender` exits before the `XMLSocketAppender` is closed either explicitly or subsequent to destruction, then there might be untransmitted data in the pipe which might be lost.
  To avoid lost data, it is usually sufficient to close the `XMLSocketAppender` either explicitly or by calling the LogManager::shutdown method before exiting the application.

## Constructor & Destructor Documentation

XMLSocketAppender | ( |  | ) |

~XMLSocketAppender | ( |  | ) |

XMLSocketAppender | ( | helpers::InetAddressPtr | address,
|  | int | port
| ) |  |

Connects to remote server at `address` and `port`.

XMLSocketAppender | ( | const LogString & | host,
|  | int | port
| ) |  |

Connects to remote server at `host` and `port`.

## Member Function Documentation

void append | ( | const spi::LoggingEventPtr & | event,
|  | log4cxx::helpers::Pool & | p
| ) |  |

protected virtual

Subclasses of `AppenderSkeleton` should implement this method to perform actual logging.

See also AppenderSkeleton::doAppend method.

Implements AppenderSkeleton.

virtual void cleanUp | ( | log4cxx::helpers::Pool & | p | ) |

protected virtual

Implements SocketAppenderSkeleton.

virtual int getDefaultDelay | ( |  | ) | const

protected virtual

Implements SocketAppenderSkeleton.

virtual int getDefaultPort | ( |  | ) | const

protected virtual

Implements SocketAppenderSkeleton.

virtual void setSocket | ( | log4cxx::helpers::SocketPtr & | socket,
|  | log4cxx::helpers::Pool & | p
| ) |  |

protected virtual

Implements SocketAppenderSkeleton.

## Member Data Documentation

int DEFAULT_PORT

static

The default port number of remote logging server (4560).

int DEFAULT_RECONNECTION_DELAY

static

The default reconnection delay (30000 milliseconds or 30 seconds).

const int MAX_EVENT_LEN

static

An event XML stream cannot exceed 1024 bytes.

The documentation for this class was generated from the following file:

- xmlsocketappender.h